use 5.010001;
use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
WriteMakefile(
    NAME              => 'Xdgmime',
    VERSION_FROM      => 'lib/Xdgmime.pm', # finds $VERSION
    PREREQ_PM         => {}, # e.g., Module::Name => 1.1
    ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
      (ABSTRACT_FROM  => 'lib/Xdgmime.pm', # retrieve abstract from module
       AUTHOR         => 'root <root@>') : ()),
    LIBS              => [''], # e.g., '-lm'
    DEFINE            => '-DHAVE_MMAP', # e.g., '-DHAVE_SOMETHING'
    INC               => '-I.', # e.g., '-I. -I/usr/include/other'
	# Un-comment this if you add C files to link with later:
    OBJECT            => '$(O_FILES)', # link all the C files too
);
if  (eval {require ExtUtils::Constant; 1}) {
  # If you edit these definitions to change the constants used by this module,
  # you will need to use the generated const-c.inc and const-xs.inc
  # files to replace their "fallback" counterparts before distributing your
  # changes.
  my @names = (qw(XDG_MIME_TYPE_EMPTY XDG_MIME_TYPE_TEXTPLAIN
		 XDG_MIME_TYPE_UNKNOWN _xdg_mime_mime_type_equal
		 _xdg_mime_mime_type_subclass _xdg_mime_unalias_mime_type
		 xdg_mime_dump xdg_mime_get_generic_icon xdg_mime_get_icon
		 xdg_mime_get_max_buffer_extents xdg_mime_get_mime_parents
		 xdg_mime_get_mime_type_for_data
		 xdg_mime_get_mime_type_for_file
		 xdg_mime_get_mime_type_from_file_name
		 xdg_mime_get_mime_types_from_file_name
		 xdg_mime_is_valid_mime_type xdg_mime_list_mime_parents
		 xdg_mime_media_type_equal xdg_mime_mime_type_equal
		 xdg_mime_mime_type_subclass xdg_mime_register_reload_callback
		 xdg_mime_remove_callback xdg_mime_shutdown xdg_mime_type_empty
		 xdg_mime_type_textplain xdg_mime_type_unknown
		 xdg_mime_unalias_mime_type));
  ExtUtils::Constant::WriteConstants(
                                     NAME         => 'Xdgmime',
                                     NAMES        => \@names,
                                     DEFAULT_TYPE => 'IV',
                                     C_FILE       => 'const-c.inc',
                                     XS_FILE      => 'const-xs.inc',
                                  );

}
else {
  use File::Copy;
  use File::Spec;
  foreach my $file ('const-c.inc', 'const-xs.inc') {
    my $fallback = File::Spec->catfile('fallback', $file);
    copy ($fallback, $file) or die "Can't copy $fallback to $file: $!";
  }
}
